#include "hspm.h"

void HSPM::initHSPM()
{
    /*
    Initializes all the required Vectors/Matrices for the HSPM solver.
    */
    
    this->computeConstantInfluenceCoeffs();
    solver.compute(A_n);
    
    this->blVel = Eigen::VectorXd::Zero(N);
    this->U = Eigen::VectorXd::Zero(N);
    this->V = Eigen::VectorXd::Zero(N);
    this->dStar = Eigen::VectorXd::Zero(N);
    V_x = V_inf * cos(AoA);
    V_y = V_inf * sin(AoA);


    // TODO: Move somewhere else
    this->x_wake = Eigen::VectorXd::LinSpaced(N_wake+1, chord, L_wake+chord);
    this->y_wake = Eigen::VectorXd::Zero(N_wake+1);
    for (size_t i=0; i<N_wake+1; i++) {
        y_wake(i) = (x_wake(i)-chord) * tan(AoA);
    }
    this->x_m_wake = Eigen::VectorXd::Zero(N_wake);
    this->y_m_wake = Eigen::VectorXd::Zero(N_wake);
    for (size_t i=0; i<N_wake; i++) {
        this->x_m_wake(i) = (x_wake(i) + x_wake(i+1)) / 2;
        this->y_m_wake(i) = (y_wake(i) + y_wake(i+1)) / 2;
    }
    this->U_wake = Eigen::VectorXd::Zero(N_wake);
    this->V_wake = Eigen::VectorXd::Zero(N_wake);

}