#include "interface.h"

void HSPM::imposeBlowingVelocity(size_t i, double _blVel) 
{
    /*
    Imposes the blowing velocity to a panel.

    Parameters
    ----------
    i : size_t
        The index of the panel to impose the blowing velocity to.
    blVel : double
        The blowing velocity to impose. [m/s]
    */
    double relax = 1;
    this->blVel[i] = (1-relax)*this->blVel[i] + relax*_blVel;
}

void HSPM::setdStar(size_t i, double _dStar)
{
    /*
    Sets the dStar value for a panel.

    Parameters
    ----------
    i : size_t
        The index of the panel to set the dStar value to.
    _dStar : double
        The dStar value to set. [m]
    */
    double relax = 1;
    this->dStar[i] = (1-relax)*this->dStar[i] + relax*_dStar;
}