#include "utils.h"
#include "hspm.h"

void saveMatrix(char* fileName, Eigen::MatrixXd matrix) {
    /*
    Saves the matrix to a file in CSV format.

    Parameters
    ----------
    fileName : char*
        The name of the file to save the matrix to.
    matrix : Eigen::MatrixXd
        The matrix to save.
    */
	const static Eigen::IOFormat CSVFormat(Eigen::FullPrecision, Eigen::DontAlignCols, " ", "\n");
 
    std::ofstream file(fileName);
    if (file.is_open())
    {
        file << matrix.format(CSVFormat);
        file.close();
    }
}

void HSPM::saveCp(char* fileName) {
    /*
    Saves the pressure coefficient to a file in CSV format.

    Parameters
    ----------
    fileName : char*
        The name of the file to save the pressure coefficient to.
    */
   
    saveMatrix(fileName, Cp);
}